diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/wifi-mac-queue-scheduler.h ns-3.46/src/wifi/model/wifi-mac-queue-scheduler.h
--- ns-3.45/src/wifi/model/wifi-mac-queue-scheduler.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/wifi-mac-queue-scheduler.h	2025-10-01 18:46:32.000000000 -0700
@@ -91,32 +91,38 @@
     virtual void SetWifiMac(Ptr<WifiMac> mac);
 
     /**
-     * Get the next queue to serve, which is guaranteed to contain at least an MPDU
-     * whose lifetime has not expired. Queues containing MPDUs that cannot be sent
-     * over the given link (if any) are ignored.
+     * Get the next queue to serve, which is guaranteed to contain at least an MPDU whose lifetime
+     * has not expired. Queues containing MPDUs that cannot be sent over the given link, if any, or
+     * on any link, otherwise, are ignored if and only if <i>skipBlockedQueues</i> is true.
      *
      * @param ac the Access Category that we want to serve
      * @param linkId the ID of the link on which MPDUs contained in the returned queue must be
      *               allowed to be sent
+     * @param skipBlockedQueues whether queues containing MPDUs that cannot be sent over the given
+     *                          link, if any, or on any link, otherwise, must be ignored
      * @return the ID of the selected container queue (if any)
      */
     virtual std::optional<WifiContainerQueueId> GetNext(AcIndex ac,
-                                                        std::optional<uint8_t> linkId) = 0;
+                                                        std::optional<uint8_t> linkId,
+                                                        bool skipBlockedQueues = true) = 0;
     /**
-     * Get the next queue to serve after the given one. The returned queue is
-     * guaranteed to contain at least an MPDU whose lifetime has not expired.
-     * Queues containing MPDUs that cannot be sent over the given link (if any) are ignored.
+     * Get the next queue to serve after the given one. The returned queue is guaranteed to contain
+     * at least an MPDU whose lifetime has not expired. Queues containing MPDUs that cannot be sent
+     * over the given link, if any, or on any link, otherwise, are ignored if and only if
+     * <i>skipBlockedQueues</i> is true.
      *
      * @param ac the Access Category that we want to serve
      * @param linkId the ID of the link on which MPDUs contained in the returned queue must be
      *               allowed to be sent
      * @param prevQueueId the ID of the container queue served previously
+     * @param skipBlockedQueues whether queues containing MPDUs that cannot be sent over the given
+     *                          link, if any, or on any link, otherwise, must be ignored
      * @return the ID of the selected container queue (if any)
      */
-    virtual std::optional<WifiContainerQueueId> GetNext(
-        AcIndex ac,
-        std::optional<uint8_t> linkId,
-        const WifiContainerQueueId& prevQueueId) = 0;
+    virtual std::optional<WifiContainerQueueId> GetNext(AcIndex ac,
+                                                        std::optional<uint8_t> linkId,
+                                                        const WifiContainerQueueId& prevQueueId,
+                                                        bool skipBlockedQueues = true) = 0;
 
     /**
      * Get the list of the IDs of the links the given MPDU (belonging to the given
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/wifi-mac-queue-scheduler-impl.h ns-3.46/src/wifi/model/wifi-mac-queue-scheduler-impl.h
--- ns-3.45/src/wifi/model/wifi-mac-queue-scheduler-impl.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/wifi-mac-queue-scheduler-impl.h	2025-10-01 18:46:32.000000000 -0700
@@ -24,6 +24,7 @@
 #include <vector>
 
 class WifiMacQueueDropOldestTest;
+class WifiMacQueueFlushTest;
 
 namespace ns3
 {
@@ -42,8 +43,9 @@
 class WifiMacQueueSchedulerImpl : public WifiMacQueueScheduler
 {
   public:
-    /// allow WifiMacQueueDropOldestTest class access
+    /// allow test classes access
     friend class ::WifiMacQueueDropOldestTest;
+    friend class ::WifiMacQueueFlushTest;
 
     /**
      * @brief Get the type ID.
@@ -58,15 +60,18 @@
 
     /** @copydoc ns3::WifiMacQueueScheduler::SetWifiMac */
     void SetWifiMac(Ptr<WifiMac> mac) final;
-    /** @copydoc ns3::WifiMacQueueScheduler::GetNext(AcIndex,std::optional<uint8_t>) */
-    std::optional<WifiContainerQueueId> GetNext(AcIndex ac, std::optional<uint8_t> linkId) final;
+    /** @copydoc ns3::WifiMacQueueScheduler::GetNext(AcIndex,std::optional<uint8_t>,bool) */
+    std::optional<WifiContainerQueueId> GetNext(AcIndex ac,
+                                                std::optional<uint8_t> linkId,
+                                                bool skipBlockedQueues = true) final;
     /**
      *  @copydoc ns3::WifiMacQueueScheduler::GetNext(AcIndex,std::optional<uint8_t>,
-     *           const WifiContainerQueueId&)
+     *           const WifiContainerQueueId&,bool)
      */
     std::optional<WifiContainerQueueId> GetNext(AcIndex ac,
                                                 std::optional<uint8_t> linkId,
-                                                const WifiContainerQueueId& prevQueueId) final;
+                                                const WifiContainerQueueId& prevQueueId,
+                                                bool skipBlockedQueues = true) final;
     /** @copydoc ns3::WifiMacQueueScheduler::GetLinkIds */
     std::list<uint8_t> GetLinkIds(AcIndex ac,
                                   Ptr<const WifiMpdu> mpdu,
@@ -200,19 +205,23 @@
     typename QueueInfoMap::iterator InitQueueInfo(AcIndex ac, Ptr<const WifiMpdu> mpdu);
 
     /**
-     * Get the next queue to serve. The search starts from the given one. The returned
-     * queue is guaranteed to contain at least an MPDU whose lifetime has not expired.
-     * Queues containing MPDUs that cannot be sent over the given link are ignored.
+     * Get the next queue to serve. The search starts from the given one. The returned queue is
+     * guaranteed to contain at least an MPDU whose lifetime has not expired. Queues containing
+     * MPDUs that cannot be sent over the given link, if any, or on any link, otherwise, are ignored
+     * if and only if <i>skipBlockedQueues</i> is true.
      *
      * @param ac the Access Category that we want to serve
      * @param linkId the ID of the link on which MPDUs contained in the returned queue must be
      *               allowed to be sent
      * @param sortedQueuesIt iterator pointing to the queue we start the search from
+     * @param skipBlockedQueues whether queues containing MPDUs that cannot be sent over the given
+     *                          link, if any, or on any link, otherwise, must be ignored
      * @return the ID of the selected container queue (if any)
      */
     std::optional<WifiContainerQueueId> DoGetNext(AcIndex ac,
                                                   std::optional<uint8_t> linkId,
-                                                  typename SortedQueues::iterator sortedQueuesIt);
+                                                  typename SortedQueues::iterator sortedQueuesIt,
+                                                  bool skipBlockedQueues);
 
     /**
      * Check whether an MPDU has to be dropped before enqueuing the given MPDU.
@@ -703,19 +712,22 @@
 
 template <class Priority, class Compare>
 std::optional<WifiContainerQueueId>
-WifiMacQueueSchedulerImpl<Priority, Compare>::GetNext(AcIndex ac, std::optional<uint8_t> linkId)
+WifiMacQueueSchedulerImpl<Priority, Compare>::GetNext(AcIndex ac,
+                                                      std::optional<uint8_t> linkId,
+                                                      bool skipBlockedQueues)
 {
-    NS_LOG_FUNCTION(this << +ac << linkId.has_value());
-    return DoGetNext(ac, linkId, m_perAcInfo[ac].sortedQueues.begin());
+    NS_LOG_FUNCTION(this << +ac << linkId.has_value() << skipBlockedQueues);
+    return DoGetNext(ac, linkId, m_perAcInfo[ac].sortedQueues.begin(), skipBlockedQueues);
 }
 
 template <class Priority, class Compare>
 std::optional<WifiContainerQueueId>
 WifiMacQueueSchedulerImpl<Priority, Compare>::GetNext(AcIndex ac,
                                                       std::optional<uint8_t> linkId,
-                                                      const WifiContainerQueueId& prevQueueId)
+                                                      const WifiContainerQueueId& prevQueueId,
+                                                      bool skipBlockedQueues)
 {
-    NS_LOG_FUNCTION(this << +ac << linkId.has_value());
+    NS_LOG_FUNCTION(this << +ac << linkId.has_value() << skipBlockedQueues);
 
     auto queueInfoIt = m_perAcInfo[ac].queueInfoMap.find(prevQueueId);
     NS_ABORT_IF(queueInfoIt == m_perAcInfo[ac].queueInfoMap.end() ||
@@ -724,7 +736,7 @@
     auto sortedQueuesIt = queueInfoIt->second.priorityIt.value();
     NS_ABORT_IF(sortedQueuesIt == m_perAcInfo[ac].sortedQueues.end());
 
-    return DoGetNext(ac, linkId, ++sortedQueuesIt);
+    return DoGetNext(ac, linkId, ++sortedQueuesIt, skipBlockedQueues);
 }
 
 template <class Priority, class Compare>
@@ -732,9 +744,10 @@
 WifiMacQueueSchedulerImpl<Priority, Compare>::DoGetNext(
     AcIndex ac,
     std::optional<uint8_t> linkId,
-    typename SortedQueues::iterator sortedQueuesIt)
+    typename SortedQueues::iterator sortedQueuesIt,
+    bool skipBlockedQueues)
 {
-    NS_LOG_FUNCTION(this << +ac << linkId.has_value());
+    NS_LOG_FUNCTION(this << +ac << linkId.has_value() << skipBlockedQueues);
     NS_ASSERT(static_cast<uint8_t>(ac) < AC_UNDEF);
 
     while (sortedQueuesIt != m_perAcInfo[ac].sortedQueues.end())
@@ -743,11 +756,13 @@
         const auto& linkIds = queueInfoPair.second.linkIds;
         typename std::decay_t<decltype(linkIds)>::const_iterator linkIt;
 
-        if (!linkId.has_value() ||
-            ((linkIt = linkIds.find(*linkId)) != linkIds.cend() && linkIt->second.none()))
+        if (!skipBlockedQueues ||
+            std::any_of(linkIds.cbegin(), linkIds.cend(), [&linkId](const auto& linkIdMask) {
+                return (!linkId.has_value() || linkId == linkIdMask.first) &&
+                       linkIdMask.second.none();
+            }))
         {
-            // Packets in this queue can be sent over the link we got channel access on.
-            // Now remove packets with expired lifetime from this queue.
+            // Remove packets with expired lifetime from this queue.
             // In case the queue becomes empty, the queue is removed from the sorted
             // list and sortedQueuesIt is invalidated; thus, store an iterator to the
             // previous queue in the sorted list (if any) to resume the search afterwards.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/wifi-mac-trailer.h ns-3.46/src/wifi/model/wifi-mac-trailer.h
--- ns-3.45/src/wifi/model/wifi-mac-trailer.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/wifi-mac-trailer.h	2025-10-01 18:46:32.000000000 -0700
@@ -9,7 +9,7 @@
 #ifndef WIFI_MAC_TRAILER_H
 #define WIFI_MAC_TRAILER_H
 
-#include "wifi-constants.h"
+#include "wifi-standard-constants.h"
 
 #include "ns3/trailer.h"
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/wifi-mode.h ns-3.46/src/wifi/model/wifi-mode.h
--- ns-3.45/src/wifi/model/wifi-mode.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/wifi-mode.h	2025-10-01 18:46:32.000000000 -0700
@@ -10,8 +10,8 @@
 #ifndef WIFI_MODE_H
 #define WIFI_MODE_H
 
-#include "wifi-constants.h"
 #include "wifi-phy-common.h"
+#include "wifi-standard-constants.h"
 
 #include "ns3/attribute-helper.h"
 #include "ns3/callback.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/wifi-net-device.cc ns-3.46/src/wifi/model/wifi-net-device.cc
--- ns-3.45/src/wifi/model/wifi-net-device.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/wifi-net-device.cc	2025-10-01 18:46:32.000000000 -0700
@@ -12,6 +12,7 @@
 #include "sta-wifi-mac.h"
 #include "wifi-phy.h"
 
+#include "ns3/boolean.h"
 #include "ns3/channel.h"
 #include "ns3/eht-configuration.h"
 #include "ns3/he-configuration.h"
@@ -655,4 +656,20 @@
     return (m_standard >= WIFI_STANDARD_80211be ? m_ehtConfiguration : nullptr);
 }
 
+bool
+WifiNetDevice::IsEmlsrActivated() const
+{
+    if (!m_ehtConfiguration)
+    {
+        return false;
+    }
+
+    BooleanValue emlsrActivated;
+    if (!m_ehtConfiguration->GetAttributeFailSafe("EmlsrActivated", emlsrActivated))
+    {
+        return false;
+    }
+    return emlsrActivated.Get();
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/wifi-net-device.h ns-3.46/src/wifi/model/wifi-net-device.h
--- ns-3.45/src/wifi/model/wifi-net-device.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/wifi-net-device.h	2025-10-01 18:46:32.000000000 -0700
@@ -169,6 +169,11 @@
      */
     Ptr<EhtConfiguration> GetEhtConfiguration() const;
 
+    /**
+     *  @return true if device supports EMLSR, otherwise false
+     */
+    bool IsEmlsrActivated() const;
+
     void SetIfIndex(const uint32_t index) override;
     uint32_t GetIfIndex() const override;
     Ptr<Channel> GetChannel() const override;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/wifi-ns3-constants.h ns-3.46/src/wifi/model/wifi-ns3-constants.h
--- ns-3.45/src/wifi/model/wifi-ns3-constants.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.46/src/wifi/model/wifi-ns3-constants.h	2025-10-01 18:46:32.000000000 -0700
@@ -0,0 +1,29 @@
+/*
+ * Copyright (c) 2025
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Sharan Naribole <sharan.naribole@gmail.com>
+ */
+
+#ifndef WIFI_NS3_CONSTANTS_H
+#define WIFI_NS3_CONSTANTS_H
+
+/**
+ * @file
+ * @ingroup wifi
+ * Declaration of default values used across wifi module
+ */
+
+namespace ns3
+{
+
+/// UL MU Data Disable flag at non-AP STA
+static constexpr bool DEFAULT_WIFI_UL_MU_DATA_DISABLE{false};
+
+/// UL MU Data Disable Rx support at AP
+static constexpr bool DEFAULT_WIFI_UL_MU_DATA_DISABLE_RX{true};
+
+} // namespace ns3
+
+#endif /* WIFI_NS3_CONSTANTS_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/wifi-phy.cc ns-3.46/src/wifi/model/wifi-phy.cc
--- ns-3.45/src/wifi/model/wifi-phy.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/wifi-phy.cc	2025-10-01 18:46:32.000000000 -0700
@@ -12,6 +12,7 @@
 #include "error-rate-model.h"
 #include "frame-capture-model.h"
 #include "interference-helper.h"
+#include "phy-entity.h"
 #include "preamble-detection-model.h"
 #include "wifi-net-device.h"
 #include "wifi-ppdu.h"
@@ -19,7 +20,6 @@
 #include "wifi-radio-energy-model.h"
 #include "wifi-utils.h"
 
-#include "ns3/attribute-container.h"
 #include "ns3/channel.h"
 #include "ns3/dsss-phy.h"
 #include "ns3/eht-phy.h" //also includes OFDM, HT, VHT and HE
@@ -32,7 +32,6 @@
 #include "ns3/random-variable-stream.h"
 #include "ns3/simulator.h"
 #include "ns3/string.h"
-#include "ns3/tuple.h"
 #include "ns3/vht-configuration.h"
 
 #include <algorithm>
@@ -88,27 +87,10 @@
                 "Note that the channel width can be left unspecified (0) if the channel "
                 "number uniquely identify a frequency channel for the given standard and band.",
                 StringValue("{0, 0, BAND_UNSPECIFIED, 0}"),
-                MakeAttributeContainerAccessor<
-                    TupleValue<UintegerValue, UintegerValue, EnumValue<WifiPhyBand>, UintegerValue>,
-                    ';'>(static_cast<void (WifiPhy::*)(const ChannelSegments&)>(
-                    &WifiPhy::SetOperatingChannel)),
-                MakeAttributeContainerChecker<
-                    TupleValue<UintegerValue, UintegerValue, EnumValue<WifiPhyBand>, UintegerValue>,
-                    ';'>(MakeTupleChecker<UintegerValue,
-                                          UintegerValue,
-                                          EnumValue<WifiPhyBand>,
-                                          UintegerValue>(
-                    MakeUintegerChecker<uint8_t>(0, 233),
-                    MakeUintegerChecker<MHz_u>(0, 320),
-                    MakeEnumChecker(WifiPhyBand::WIFI_PHY_BAND_2_4GHZ,
-                                    "BAND_2_4GHZ",
-                                    WifiPhyBand::WIFI_PHY_BAND_5GHZ,
-                                    "BAND_5GHZ",
-                                    WifiPhyBand::WIFI_PHY_BAND_6GHZ,
-                                    "BAND_6GHZ",
-                                    WifiPhyBand::WIFI_PHY_BAND_UNSPECIFIED,
-                                    "BAND_UNSPECIFIED"),
-                    MakeUintegerChecker<uint8_t>(0, 15))))
+                MakeAttributeContainerAccessor<ChannelTupleValue, ';'>(
+                    static_cast<void (WifiPhy::*)(const ChannelSegments&)>(
+                        &WifiPhy::SetOperatingChannel)),
+                GetChannelSegmentsChecker())
             .AddAttribute("Frequency",
                           "The center frequency (MHz) of the current operating channel.",
                           TypeId::ATTR_GET,
@@ -385,6 +367,24 @@
     return tid;
 }
 
+Ptr<const AttributeChecker>
+WifiPhy::GetChannelSegmentsChecker()
+{
+    return MakeAttributeContainerChecker<ChannelTupleValue, ';'>(
+        MakeTupleChecker<UintegerValue, UintegerValue, EnumValue<WifiPhyBand>, UintegerValue>(
+            MakeUintegerChecker<uint8_t>(0, 233),
+            MakeUintegerChecker<uint16_t>(0, 320),
+            MakeEnumChecker(WifiPhyBand::WIFI_PHY_BAND_2_4GHZ,
+                            "BAND_2_4GHZ",
+                            WifiPhyBand::WIFI_PHY_BAND_5GHZ,
+                            "BAND_5GHZ",
+                            WifiPhyBand::WIFI_PHY_BAND_6GHZ,
+                            "BAND_6GHZ",
+                            WifiPhyBand::WIFI_PHY_BAND_UNSPECIFIED,
+                            "BAND_UNSPECIFIED"),
+            MakeUintegerChecker<uint8_t>(0, 15)));
+}
+
 WifiPhy::WifiPhy()
     : m_phyId(0),
       m_txMpduReferenceNumber(0xffffffff),
@@ -470,10 +470,10 @@
     m_phyEntities.clear();
 }
 
-std::map<WifiModulationClass, Ptr<PhyEntity>>&
+std::map<WifiModulationClass, std::shared_ptr<PhyEntity>>&
 WifiPhy::GetStaticPhyEntities()
 {
-    static std::map<WifiModulationClass, Ptr<PhyEntity>> g_staticPhyEntities;
+    static std::map<WifiModulationClass, std::shared_ptr<PhyEntity>> g_staticPhyEntities;
     return g_staticPhyEntities;
 }
 
@@ -756,7 +756,7 @@
     return m_interference->GetErrorRateModel()->CalculateSnr(txVector, ber);
 }
 
-const Ptr<const PhyEntity>
+const std::shared_ptr<const PhyEntity>
 WifiPhy::GetStaticPhyEntity(WifiModulationClass modulation)
 {
     const auto it = GetStaticPhyEntities().find(modulation);
@@ -765,7 +765,7 @@
     return it->second;
 }
 
-Ptr<PhyEntity>
+std::shared_ptr<PhyEntity>
 WifiPhy::GetPhyEntity(WifiModulationClass modulation) const
 {
     const auto it = m_phyEntities.find(modulation);
@@ -774,19 +774,19 @@
     return it->second;
 }
 
-Ptr<PhyEntity>
+std::shared_ptr<PhyEntity>
 WifiPhy::GetPhyEntity(WifiStandard standard) const
 {
     return GetPhyEntity(GetModulationClassForStandard(standard));
 }
 
-Ptr<PhyEntity>
+std::shared_ptr<PhyEntity>
 WifiPhy::GetLatestPhyEntity() const
 {
     return GetPhyEntity(m_standard);
 }
 
-Ptr<PhyEntity>
+std::shared_ptr<PhyEntity>
 WifiPhy::GetPhyEntityForPpdu(const Ptr<const WifiPpdu> ppdu) const
 {
     NS_ABORT_IF(!ppdu);
@@ -807,7 +807,7 @@
 }
 
 void
-WifiPhy::AddStaticPhyEntity(WifiModulationClass modulation, Ptr<PhyEntity> phyEntity)
+WifiPhy::AddStaticPhyEntity(WifiModulationClass modulation, std::shared_ptr<PhyEntity> phyEntity)
 {
     NS_ASSERT_MSG(!GetStaticPhyEntities().contains(modulation),
                   "The PHY entity has already been added. The setting should only be done once per "
@@ -816,7 +816,7 @@
 }
 
 void
-WifiPhy::AddPhyEntity(WifiModulationClass modulation, Ptr<PhyEntity> phyEntity)
+WifiPhy::AddPhyEntity(WifiModulationClass modulation, std::shared_ptr<PhyEntity> phyEntity)
 {
     NS_LOG_FUNCTION(this << modulation);
     NS_ABORT_MSG_IF(!GetStaticPhyEntities().contains(modulation),
@@ -868,7 +868,7 @@
 WifiPhy::Configure80211a()
 {
     NS_LOG_FUNCTION(this);
-    AddPhyEntity(WIFI_MOD_CLASS_OFDM, Create<OfdmPhy>());
+    AddPhyEntity(WIFI_MOD_CLASS_OFDM, std::make_shared<OfdmPhy>());
 
     // See Table 17-21 "OFDM PHY characteristics" of 802.11-2016
     SetSifs(OFDM_SIFS_TIME_20MHZ);
@@ -882,7 +882,7 @@
 WifiPhy::Configure80211b()
 {
     NS_LOG_FUNCTION(this);
-    Ptr<DsssPhy> phyEntity = Create<DsssPhy>();
+    std::shared_ptr<DsssPhy> phyEntity = std::make_shared<DsssPhy>();
     AddPhyEntity(WIFI_MOD_CLASS_HR_DSSS, phyEntity);
     AddPhyEntity(WIFI_MOD_CLASS_DSSS, phyEntity); // when plain DSSS modes are used
 
@@ -903,7 +903,7 @@
     // if the user sets the ShortSlotTimeSupported flag to true and when the BSS
     // consists of only ERP STAs capable of supporting this option.
     Configure80211b();
-    AddPhyEntity(WIFI_MOD_CLASS_ERP_OFDM, Create<ErpOfdmPhy>());
+    AddPhyEntity(WIFI_MOD_CLASS_ERP_OFDM, std::make_shared<ErpOfdmPhy>());
 }
 
 void
@@ -912,7 +912,7 @@
     NS_LOG_FUNCTION(this);
     if (GetChannelWidth() == MHz_u{10})
     {
-        AddPhyEntity(WIFI_MOD_CLASS_OFDM, Create<OfdmPhy>(OFDM_PHY_10_MHZ));
+        AddPhyEntity(WIFI_MOD_CLASS_OFDM, std::make_shared<OfdmPhy>(OFDM_PHY_10_MHZ));
 
         // See Table 17-21 "OFDM PHY characteristics" of 802.11-2016
         SetSifs(OFDM_SIFS_TIME_10MHZ);
@@ -921,7 +921,7 @@
     }
     else if (GetChannelWidth() == MHz_u{5})
     {
-        AddPhyEntity(WIFI_MOD_CLASS_OFDM, Create<OfdmPhy>(OFDM_PHY_5_MHZ));
+        AddPhyEntity(WIFI_MOD_CLASS_OFDM, std::make_shared<OfdmPhy>(OFDM_PHY_5_MHZ));
 
         // See Table 17-21 "OFDM PHY characteristics" of 802.11-2016
         SetSifs(OFDM_SIFS_TIME_5MHZ);
@@ -946,7 +946,7 @@
     {
         Configure80211a();
     }
-    AddPhyEntity(WIFI_MOD_CLASS_HT, Create<HtPhy>(m_txSpatialStreams));
+    AddPhyEntity(WIFI_MOD_CLASS_HT, std::make_shared<HtPhy>(m_txSpatialStreams));
 }
 
 void
@@ -954,7 +954,7 @@
 {
     NS_LOG_FUNCTION(this);
     Configure80211n();
-    AddPhyEntity(WIFI_MOD_CLASS_VHT, Create<VhtPhy>());
+    AddPhyEntity(WIFI_MOD_CLASS_VHT, std::make_shared<VhtPhy>());
 }
 
 void
@@ -969,7 +969,7 @@
     {
         Configure80211ac();
     }
-    AddPhyEntity(WIFI_MOD_CLASS_HE, Create<HePhy>());
+    AddPhyEntity(WIFI_MOD_CLASS_HE, std::make_shared<HePhy>());
 }
 
 void
@@ -977,7 +977,7 @@
 {
     NS_LOG_FUNCTION(this);
     Configure80211ax();
-    AddPhyEntity(WIFI_MOD_CLASS_EHT, Create<EhtPhy>());
+    AddPhyEntity(WIFI_MOD_CLASS_EHT, std::make_shared<EhtPhy>());
 }
 
 void
@@ -1011,7 +1011,7 @@
     if (!m_operatingChannel.IsSet())
     {
         NS_LOG_DEBUG("Setting the operating channel first");
-        SetOperatingChannel(m_channelSettings);
+        SetOperatingChannel(m_channelCfg);
         // return because we are called back by SetOperatingChannel
         return;
     }
@@ -1123,36 +1123,39 @@
 WifiPhy::SetOperatingChannel(const WifiPhyOperatingChannel& channel)
 {
     NS_LOG_FUNCTION(this << channel);
-    ChannelSegments segments{};
+    WifiChannelConfig cfg;
     for (std::size_t segmentId = 0; segmentId < channel.GetNSegments(); ++segmentId)
     {
-        segments.emplace_back(channel.GetNumber(segmentId),
-                              channel.GetWidth(segmentId),
-                              channel.GetPhyBand(),
-                              channel.GetPrimaryChannelIndex(MHz_u{20}));
+        cfg.segments.emplace_back(channel.GetNumber(segmentId),
+                                  channel.GetWidth(segmentId),
+                                  channel.GetPhyBand(),
+                                  channel.GetPrimaryChannelIndex(MHz_u{20}));
     }
-    SetOperatingChannel(segments);
+    SetOperatingChannel(cfg);
 }
 
 void
-WifiPhy::SetOperatingChannel(const ChannelTuple& tuple)
+WifiPhy::SetOperatingChannel(const ChannelSegments& channelSegments)
 {
-    SetOperatingChannel(ChannelSegments{tuple});
+    SetOperatingChannel(WifiChannelConfig(channelSegments));
 }
 
 void
-WifiPhy::SetOperatingChannel(const ChannelSegments& channelSegments)
+WifiPhy::SetOperatingChannel(const WifiChannelConfig& channelCfg)
 {
-    NS_LOG_FUNCTION(this << +std::get<0>(channelSegments.front())
-                         << std::get<1>(channelSegments.front())
-                         << static_cast<WifiPhyBand>(std::get<2>(channelSegments.front()))
-                         << +std::get<3>(channelSegments.front()));
+    NS_LOG_FUNCTION(this << +channelCfg.front().number << channelCfg.front().width
+                         << channelCfg.front().band << +channelCfg.front().p20Index);
 
-    m_channelSettings = channelSegments;
+    if (IsInitialized() && m_operatingChannel.IsSet() && (m_channelCfg == channelCfg))
+    {
+        NS_LOG_DEBUG("Already operating on requested channel");
+        return;
+    }
 
     if (m_standard == WIFI_STANDARD_UNSPECIFIED)
     {
         NS_LOG_DEBUG("Channel information will be applied when a standard is configured");
+        m_channelCfg = channelCfg;
         return;
     }
 
@@ -1167,12 +1170,13 @@
         if (delay.value().IsStrictlyPositive())
         {
             // switching channel has been postponed
-            void (WifiPhy::*fp)(const ChannelSegments&) = &WifiPhy::SetOperatingChannel;
-            Simulator::Schedule(delay.value(), fp, this, channelSegments);
+            Simulator::Schedule(delay.value(), [=, this] { SetOperatingChannel(channelCfg); });
             return;
         }
     }
 
+    m_channelCfg = channelCfg;
+
     // channel can be switched now.
     DoChannelSwitch();
 }
@@ -1219,60 +1223,61 @@
 }
 
 void
-WifiPhy::DoChannelSwitch()
+WifiPhy::SetUnspecifiedChannelParams(WifiChannelConfig& channelCfg, WifiStandard standard)
 {
-    NS_LOG_FUNCTION(this);
-
-    m_powerRestricted = false;
-    m_channelAccessRequested = false;
-
-    // Update unspecified parameters with default values
     std::optional<uint8_t> prevChannelNumber{};
-    for (auto& [number, width, band, primary20] : m_channelSettings)
+    for (auto& [number, width, band, primary20] : channelCfg.segments)
     {
         if (band == WIFI_PHY_BAND_UNSPECIFIED)
         {
-            band = GetDefaultPhyBand(m_standard);
+            band = GetDefaultPhyBand(standard);
         }
         if (width == MHz_u{0} && number == 0)
         {
-            width = GetDefaultChannelWidth(m_standard, static_cast<WifiPhyBand>(band));
+            width = GetDefaultChannelWidth(standard, static_cast<WifiPhyBand>(band));
         }
         if (number == 0)
         {
-            number =
-                WifiPhyOperatingChannel::GetDefaultChannelNumber(width,
-                                                                 m_standard,
-                                                                 static_cast<WifiPhyBand>(band),
-                                                                 prevChannelNumber);
+            number = WifiPhyOperatingChannel::GetDefaultChannelNumber(width,
+                                                                      standard,
+                                                                      band,
+                                                                      prevChannelNumber);
         }
         prevChannelNumber = number;
     }
+}
+
+void
+WifiPhy::DoChannelSwitch()
+{
+    NS_LOG_FUNCTION(this);
+
+    m_powerRestricted = false;
+    m_channelAccessRequested = false;
+
+    // Update unspecified parameters with default values
+    SetUnspecifiedChannelParams(m_channelCfg, m_standard);
 
     // We need to call SetStandard if this is the first time we set a channel or we
     // are changing PHY band. Checking if the new PHY band is different than the
     // previous one covers both cases because initially the PHY band is unspecified
-    bool changingPhyBand =
-        (static_cast<WifiPhyBand>(std::get<2>(m_channelSettings.front())) != m_band);
+    const auto changingPhyBand = (m_channelCfg.front().band != m_band);
 
     NS_ABORT_MSG_IF(IsInitialized() && m_fixedPhyBand && changingPhyBand,
                     "Trying to change PHY band while prohibited.");
 
-    m_band = static_cast<WifiPhyBand>(std::get<2>(m_channelSettings.front()));
+    m_band = m_channelCfg.front().band;
 
     NS_LOG_DEBUG("switching channel");
     std::vector<FrequencyChannelInfo> segments{};
-    std::transform(m_channelSettings.cbegin(),
-                   m_channelSettings.cend(),
+    std::transform(m_channelCfg.segments.cbegin(),
+                   m_channelCfg.segments.cend(),
                    std::back_inserter(segments),
-                   [this](const auto& channelTuple) {
-                       return FrequencyChannelInfo{std::get<0>(channelTuple),
-                                                   MHz_u{0},
-                                                   std::get<1>(channelTuple),
-                                                   m_band};
+                   [this](const auto& segment) {
+                       return FrequencyChannelInfo{segment.number, MHz_u{0}, segment.width, m_band};
                    });
     m_operatingChannel.Set(segments, m_standard);
-    m_operatingChannel.SetPrimary20Index(std::get<3>(m_channelSettings.front()));
+    m_operatingChannel.SetPrimary20Index(m_channelCfg.front().p20Index);
 
     // check that the channel width is supported
     if (const auto chWidth = GetChannelWidth();
@@ -1335,7 +1340,7 @@
         auto phyEntity = m_phyEntities.find(WIFI_MOD_CLASS_HT);
         if (phyEntity != m_phyEntities.end())
         {
-            Ptr<HtPhy> htPhy = DynamicCast<HtPhy>(phyEntity->second);
+            std::shared_ptr<HtPhy> htPhy = std::dynamic_pointer_cast<HtPhy>(phyEntity->second);
             if (htPhy)
             {
                 htPhy->SetMaxSupportedNss(
@@ -1380,7 +1385,7 @@
     std::list<uint8_t> list;
     for (const auto& phyEntity : m_phyEntities)
     {
-        Ptr<HtPhy> htPhy = DynamicCast<HtPhy>(phyEntity.second);
+        std::shared_ptr<HtPhy> htPhy = std::dynamic_pointer_cast<HtPhy>(phyEntity.second);
         if (htPhy)
         {
             list.emplace_back(htPhy->GetBssMembershipSelector());
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/wifi-phy-common.h ns-3.46/src/wifi/model/wifi-phy-common.h
--- ns-3.45/src/wifi/model/wifi-phy-common.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/wifi-phy-common.h	2025-10-01 18:46:32.000000000 -0700
@@ -728,6 +728,45 @@
     {WIFI_CHANLIST_SECONDARY160, 12.0},
 };
 
+/**
+ * A struct for both SNR and PER
+ */
+struct SnrPer
+{
+    double snr{0.0}; ///< SNR in linear scale
+    double per{1.0}; ///< PER
+
+    /**
+     * Default constructor.
+     */
+    SnrPer()
+    {
+    }
+
+    /**
+     * Constructor for SnrPer.
+     *
+     * @param s the SNR in linear scale
+     * @param p the PER
+     */
+    SnrPer(double s, double p)
+        : snr(s),
+          per(p)
+    {
+    }
+};
+
+/**
+ * A pair containing information on the PHY header chunk, namely
+ * the start and stop times of the chunk and the WifiMode used.
+ */
+typedef std::pair<std::pair<Time /* start */, Time /* stop */>, WifiMode> PhyHeaderChunkInfo;
+/**
+ * A map of PhyHeaderChunkInfo elements per PPDU field.
+ * @see PhyHeaderChunkInfo
+ */
+typedef std::map<WifiPpduField, PhyHeaderChunkInfo> PhyHeaderSections;
+
 } // namespace ns3
 
 #endif /* WIFI_PHY_COMMON_H */
